| kspaceFirstOrder3D-CUDA 1.1 The CUDA/C++ implementation of the k-wave toolbox for the time-domain simulation of acoustic wave fields in 3D

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | Public Attributes | Friends | List of all members
TDimensionSizes Struct Reference

Structure with 4D dimension sizes (3 in space and 1 in time). More...

`#include <DimensionSizes.h>`

## Public Member Functions
| TDimensionSizes ()
| Default constructor.
| TDimensionSizes (size_t x, size_t y, size_t z, size_t t=0)
| Constructor. More...
size_t | GetElementCount () const
| Get element count, in 3D only spatial domain, in 4D with time. More...
bool | Is3D () const
| Does the object include spatial dimensions only?
bool | Is4D () const
| Does the object include spatial and temporal dimensions?
bool | operator== (const TDimensionSizes &other) const
| Operator ==. More...
bool | operator!= (const TDimensionSizes &other) const
| Operator !=. More...

## Public Attributes
size_t | nx
| number of elements in the x direction
size_t | ny
| number of elements in the y direction
size_t | nz
| number of elements in the z direction
size_t | nt
| Number of time steps (for time series datasets).

## Friends
TDimensionSizes | operator- (const TDimensionSizes &op1, const TDimensionSizes &op2)

## Detailed Description

Structure with 4D dimension sizes (3 in space and 1 in time). The structure can be used for 3D (the time is then set to 1).
The structure contains only POD, so no C++ stuff is necessary.

Definition at line 66 of file DimensionSizes.h.

## Constructor & Destructor Documentation

TDimensionSizes::TDimensionSizes | ( | size_t | x,
|  | size_t | y,
|  | size_t | z,
|  | size_t | t = `0`
| ) |  |
| inline

Constructor.

Parameters

  [in] | x,y,z,t | - Three spatial dimensions and time.

Definition at line 76 of file DimensionSizes.h.

## Member Function Documentation

size_t TDimensionSizes::GetElementCount | ( |  | ) | const
| inline

Get element count, in 3D only spatial domain, in 4D with time.

Returns
  spatial element count or number of elements over time.

Definition at line 85 of file DimensionSizes.h.

Here is the call graph for this function:

Here is the caller graph for this function:

bool TDimensionSizes::operator!= | ( | const TDimensionSizes & | other | ) | const
| inline

Parameters

  [in] | other | - the second operand to compare with

Returns
  true if !=

Definition at line 117 of file DimensionSizes.h.

bool TDimensionSizes::operator== | ( | const TDimensionSizes & | other | ) | const
| inline

Parameters

  [in] | other | - The second operand to compare with

Returns
  true if the dimension sizes are equal

Definition at line 107 of file DimensionSizes.h.

## Friends And Related Function Documentation

TDimensionSizes operator- | ( | const TDimensionSizes & | op1,
|  | const TDimensionSizes & | op2
| ) |  |
| friend

Operator - Get the size of the cube defined by two corners

Parameters

  [in] | op1 | - Usually bottom right corner
  [in] | op2 | - Usually top left corner

Returns
  the size of the inner cuboid

Definition at line 129 of file DimensionSizes.h.

The documentation for this struct was generated from the following file:

- Utils/DimensionSizes.h